c*******************************************************************
c* Short description                                               *
c*   Creates a voxel geometry data file                            *
c*                                                                 *
c* Last update                                                     *
c*   2001-03-10 JS Adapted to PENGEOM2.                            *
c*   1998-08-11 JS Created.                                        *
c*******************************************************************
      program main
      implicit none
      integer*4 kpar,ibody,mat,ilb
      real*8 e,x,y,z,u,v,w,wght
      common/track/e,x,y,z,u,v,w,wght,kpar,ibody,mat,ilb

      character infile*60, outfile*60
      integer granul,l,maxmat,hi,hj,hk,ismat
      integer*4 nxvox,nyvox,nzvox,i,j,k,nmat,nbod
      parameter (maxmat=50)
      integer eximat(maxmat)
      real*8 parinp,dx,dy,dz,dens(maxmat),infty,mindif,aveden
      real*8 dendif
      parameter (infty=1.d90)

      read(*,*)
      read(*,*)
      read(*,*) nxvox, nyvox,nzvox
      write(*,*) 'Nxvox,Nyvox,Nzvox:'
      write(*,'(1x,3(i6,1x))') nxvox,nyvox,nzvox
      read(*,*)
      read(*,*) dx, dy, dz
      write(*,*) 'dxvox,dyvox,dzvox (cm):'
      write(*,'(1x,3(1pe10.3,1x))') dx,dy,dz
      read(*,*)
      read(*,*) infile
      write(*,*) 'Reading from ', infile
      read(*,*)
      read(*,*) outfile
      write(*,*) 'Writing to ', outfile
      read(*,*)
      read(*,*) nmat
      write(*,*) 'Number of Materials ', nmat
      read(*,*)
      write(*,*) 'Mat# -- dens(g/cm^3):'
      do 8 i=1,nmat
        read (*,*) dens(i)
        write(*,'(3x,i1,1x,f5.2)') i,dens(i)
    8 continue

      granul = 1

c     **** init geometry
      open(5,file=infile)
      call geomin(parinp,0,nmat,nbod)
      close(5)
      u = 0.d0
      v = 0.d0
      w = 1.d0
      do 80 l=1,maxmat
        eximat(l) = 0
 80   continue

      write(*,*) 'genvoxel Info: reading from file '
      open(1,file=outfile)
      write(1,*)
     & 'HEADER section: DPM geometry file generated by genvoxel.f'
      write(1,*) ' '
      write(1,*) 'Nxvox,Nyvox,Nzvox:'
      write(1,'(1x,3(i6,1x))') nxvox,nyvox,nzvox
      write(1,*) 'dxvox,dyvox,dzvox (cm):'
      write(1,'(1x,3(1pe10.3,1x))') dx,dy,dz
      write(1,*) 'Mat#[nx,ny+,nz++] -- dens(g/cm^3):'
      do 10 i=1,nxvox
        do 20 j=1,nyvox
          do 30 k=1,nzvox
com: Adaptation to pengeom with granularity...
            aveden = 0.d0
            do 40 hi=1,granul
              x =  (i-1+hi/dble(granul+1))*dx
              do 50 hj=1,granul
                y =  (j-1+hj/dble(granul+1))*dy
                do 60 hk=1,granul
                  z =  (k-1+hk/dble(granul+1))*dz
                  call locate
                  if (mat.gt.nmat) then
                    write(*,*) 'genvoxel Error: invalid mat'
                    stop
                  endif
                  aveden = aveden+dens(mat)
                  eximat(mat) = 1
 60             continue
 50           continue
 40         continue
            aveden = aveden/granul**3
            mindif = infty
            do 70 l=1,nmat
com: Skip non-existent materials...
              if (eximat(l).eq.0) goto 70
              dendif = dabs(aveden-dens(l))
              if (dendif.lt.mindif) then
                mindif = dendif
                ismat = l
              endif
 70         continue
            if (aveden.gt.10.d0) then
              write(1,'(1x,i1,1x,f5.2)') ismat,aveden
            else if (aveden.gt.0.5d0) then
              write(1,'(1x,i1,1x,f5.3)') ismat,aveden
            else
              write(1,'(1x,i1,1x,1pe9.3)') ismat,aveden
            endif
 30       continue
 20     continue
      write(*,*) 'genvoxel Info: done with x-row#:',i
 10   continue

      write(1,*) ' '
      write(1,*) 'c*** end of file ********************************'
      write(1,*) ' '
      close(1)
      write(*,*) 'Have a nice day'
      write(*,*) ' '
      stop
      end


c* end of file *****************************************************


